; Firmware scheda di controllo con telecomando dell'amplificatore SB-5881-TUS V1.0 Copyright Stefano Bianchini

; #no_data
#picaxe 14m2

symbol pled = B.1
symbol anodica = B.0
symbol can1 = B.2
symbol can2 = B.3
symbol can3 = B.4
symbol mt_enable = C.0
symbol mt_a = C.1
symbol mt_b = C.2
symbol irdat = C.3
symbol enc_su = pinC.4
symbol enc_giu = pinB.5
symbol conta = b0
symbol conta2 = b1
symbol luce = b2
symbol memoria = b3
symbol tasto = b4

; Informazioni di Copyright salvate sul chip
eeprom 0,("Firmware scheda di controllo con telecomando dell'amplificatore SB-5881-TUS V1.0 Copyright Stefano Bianchini")

start0: ; Task Lampeggiatore (task slave)
low pled ; (NOTA: all'avvio il chip esegue sempre la prima istruzione del task slave, per non avere lampeggi spurii del led di poter eseguo un low del pin)
do
	toggle pled
	pause 125
	toggle pled
	pause 125
loop

; Cosa fa' appena acceso
start1: ; (task master)
suspend 0
gosub pulsasu
high pled
gosub zerovol

; Pulsa il led 20 volte per 20 secondi di ritardo dell'anodica
for conta = 1 to 20
	gosub pulsagiu
	gosub pulsasu
next conta
high pled

; Avvio dell'amplificatore
high anodica
gosub canale1
pause 250
gosub minvol

; Master loop
polling:
do

for conta = 1 to 20 ; Campiona l'encoder e cambia il canale in base al suo stato

if enc_su = 1 and enc_giu = 0 then ; Incrementa
	pause 3 ; antirimbalzo
	if enc_su = 1 and enc_giu = 0 then
		if memoria = 3 then
			gosub slampino
		else gosub destra
		endif
	endif
endif

if enc_su = 0 and enc_giu = 1 then ; Decrementa
	pause 3 ; antirimbalzo
	if enc_su = 0 and enc_giu = 1 then
		if memoria = 1 then
			gosub slampino
		else gosub sinistra
		endif
	endif
endif

next conta

high pled ; Riaccendo il led di power nel caso l'uscita dal task0 lo abbia lasciato spento

; Legge il segnale del telecomando

irin [100,polling],irdat,tasto
if tasto = 0 then ; pulsante 1 
	if memoria != 1 then
		gosub fa
		gosub canale1
		gosub fb
	else gosub slampino
	endif
elseif tasto = 1 then ; pulsante 2 
	if memoria != 2 then
		gosub fa
		gosub canale2
		gosub fb
	else gosub slampino
	endif
elseif tasto = 2 then ; pulsante 3 
	if memoria != 3 then
		gosub fa
		gosub canale3
		gosub fb
	else gosub slampino
	endif
elseif tasto = 9 then ; pulsante 0
	gosub muto
elseif tasto = 98 or tasto = 17 then ; pulsante "-" o fraccia giu'
	gosub volgiu
elseif tasto = 11 or tasto = 16 then ; pulsante "+" o freccia su'
	gosub volsu
elseif tasto = 19 then ; pulsante freccia sinistra
	gosub sinistra
elseif tasto = 18 then ; pulsante freccia destra
	gosub destra
else gosub slampino ; se viene premuto un tasto senza funzione
endif

loop

end ; Per sicurezza

; Eseguito prima del cambio di canale
fa:
resume 0
gosub zerovol
return

; Eseguito dopo il cambio del canale
fb:
gosub minvol
suspend 0
return

; Fa un lampeggino del pled
slampino:
toggle pled
pause 50
return

; Incrementa il canale
destra:
if memoria = 1 then
	resume 0
	gosub zerovol
	gosub canale2
	gosub minvol
	suspend 0
elseif memoria = 2 then
	resume 0
	gosub zerovol
	gosub canale3
	gosub minvol
	suspend 0
else gosub slampino
endif
return

; Decrementa il canale
sinistra:
if memoria = 3 then
	resume 0
	gosub zerovol
	gosub canale2
	gosub minvol
	suspend 0
elseif memoria = 2 then
	resume 0
	gosub zerovol
	gosub canale1
	gosub minvol
	suspend 0
else gosub slampino
endif
return

; pilota il motorino del potenziomentro con un'impulso per alzare il volume 
volsu:
high mt_a
pause 1
high mt_enable
pause 99
gosub motoff
return

; pilota il motorino del potenziomentro con un'impulso per abbassare il volume 
volgiu:
high mt_b
pause 1
high mt_enable
pause 99
gosub motoff
return

; spegne completamente il driver del motorino
motoff:
low mt_enable
low mt_a
low mt_b
return

; commuta i rele' ingresso su canaleN e memorizza il canale che si sta ascoltando nel registro "memoria" 
canale1:
let memoria = 1
high can1
low can2,can3
pause 250
return

canale2:
let memoria = 2
low can1,can3
high can2
pause 250
return

canale3:
let memoria = 3
low can1,can2
high can3
pause 250
return

; funzione muto 
muto:
low can1,can2,can3
resume 0
gosub zerovol
muto_:
irin [100,muto_],irdat,tasto
if tasto = 9 then ; attende che sul telecomando sia premuto nuovamente il tasto 0 per fare l'unmute
	if memoria = 1 then ; controlla il registro per riaccendere l'ultimo canale che era attivo prima del mute 
		gosub canale1
	elseif memoria = 2 then
		gosub canale2
	elseif memoria = 3 then
		gosub canale3
	endif
endif
gosub minvol
suspend 0
return

; fa un gradiente di luminosita' crescente in 11 passi del powerled (NOTA: in questa versione dell'hardware e' usata l'emulazione pwm su un pin non pwm nativo de chip)
pulsasu:
let luce = 20
for conta2 = 1 to 11
	let luce = luce + 20
	pwm pled, luce, 8
next conta2
return

; fa un gradiente di luminosita' decrescente in 11 passi del powerled 
pulsagiu:
let luce = 240
for conta2 = 1 to 11
	let luce = luce - 20
	pwm pled, luce, 8
next conta2
return

; Abbassa il volume a 0
zerovol:
for conta = 1 to 100
	gosub volgiu
next conta
return

; quando il volume e' 0 lo riporta al minimo
minvol:
for conta = 1 to 10
	gosub volsu
next conta
return
